diff -pruN 2024.5.2+ds.1-1/debian/changelog 2024.5.2+ds.1-2/debian/changelog
--- 2024.5.2+ds.1-1/debian/changelog	2024-06-16 16:45:33.000000000 +0000
+++ 2024.5.2+ds.1-2/debian/changelog	2024-06-20 19:21:07.000000000 +0000
@@ -1,3 +1,24 @@
+dask.distributed (2024.5.2+ds.1-2) unstable; urgency=medium
+
+  * Team upload.
+  * mark-tests-flaky.patch: capture more flaky tests.
+  * d/control: hardcode python3-dask version lock.
+    There is a small difference in repack extension preventing the trick.
+  * d/s/lintian-overrides: remove: now unneeded.
+  * skip-pyarrow-tests.patch: skip newly introduced test.
+  * d/rules: rewrap SKIP variable to facilitate readability.
+  * d/rules: skip tests needing Internet. (Closes: #1066799)
+  * d/{control,rules}: activate autopkgtest-pkg-pybuild.
+    This test complements the existing flaky autopkgtest test that
+    requires a testbed with Internet connection.
+  * d/t/run-tests: skip test failing reported upstream.
+    On python3.12, some failures to serialize may return RecursionErrors
+    instead of the expected TypeError and its message "Could not serialize
+    object" until this minor issue is resolved.
+  * d/control: declare compliance to standards version 4.7.0.
+
+ -- Étienne Mollier <emollier@debian.org>  Thu, 20 Jun 2024 21:21:07 +0200
+
 dask.distributed (2024.5.2+ds.1-1) unstable; urgency=medium
 
   * Team upload.
@@ -124,7 +145,7 @@ dask.distributed (2022.12.1+ds.1-2) unst
   * Remove stray files.
   * Run autopkgtest as non-root.
   * Retry flaky tests (like upstream) instead of skipping them.
-    
+
   [ Diane Trout ]
   * Disable ivp6 tests if the autopkgtest runners lack ipv6 connectivity.
     - Add autopkgtest dependency iputils-ping for ipv6 testing
diff -pruN 2024.5.2+ds.1-1/debian/control 2024.5.2+ds.1-2/debian/control
--- 2024.5.2+ds.1-1/debian/control	2024-06-16 16:45:33.000000000 +0000
+++ 2024.5.2+ds.1-2/debian/control	2024-06-20 19:21:07.000000000 +0000
@@ -45,18 +45,19 @@ Build-Depends: debhelper-compat (= 13),
                python3-zict (>= 3.0.0),
                tzdata-legacy,
                uglifyjs,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://distributed.readthedocs.io/en/latest/
 Vcs-Git: https://salsa.debian.org/python-team/packages/dask.distributed.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/dask.distributed
 Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-pybuild
 
 Package: python3-distributed
 Architecture: all
 Depends: ${misc:Depends},
          ${python3:Depends},
-         python3-dask (>= ${source:Version}),
-         python3-dask (<< ${source:Version}.1~),
+         python3-dask (>= 2024.5.2),
+         python3-dask (<< 2024.5.2.1~),
 Recommends: python3-pandas, python3-yaml
 Description: Dask Distributed computing for Python 3
  Dask.distributed is a lightweight library for distributed computing in
diff -pruN 2024.5.2+ds.1-1/debian/patches/mark-tests-flaky.patch 2024.5.2+ds.1-2/debian/patches/mark-tests-flaky.patch
--- 2024.5.2+ds.1-1/debian/patches/mark-tests-flaky.patch	2024-06-16 16:45:33.000000000 +0000
+++ 2024.5.2+ds.1-2/debian/patches/mark-tests-flaky.patch	2024-06-20 19:21:07.000000000 +0000
@@ -55,3 +55,23 @@ Forwarded: no
  async def test_collections_metadata(c, s, a, b):
      pd = pytest.importorskip("pandas")
      dd = pytest.importorskip("dask.dataframe")
+--- dask.distributed.orig/distributed/tests/test_profile.py
++++ dask.distributed/distributed/tests/test_profile.py
+@@ -26,6 +26,7 @@
+ )
+ 
+ 
++@pytest.mark.flaky(reruns=2, reruns_delay=10)
+ def test_basic():
+     def test_g():
+         sleep(0.01)
+--- dask.distributed.orig/distributed/tests/test_client.py
++++ dask.distributed/distributed/tests/test_client.py
+@@ -2251,6 +2251,7 @@
+ 
+ 
+ @gen_cluster()
++@pytest.mark.flaky(reruns=2, reruns_delay=10)
+ async def test_multi_client(s, a, b):
+     async with Client(s.address, asynchronous=True) as f:
+         async with Client(s.address, asynchronous=True) as c:
diff -pruN 2024.5.2+ds.1-1/debian/patches/skip-pyarrow-tests.patch 2024.5.2+ds.1-2/debian/patches/skip-pyarrow-tests.patch
--- 2024.5.2+ds.1-1/debian/patches/skip-pyarrow-tests.patch	2024-06-16 16:45:33.000000000 +0000
+++ 2024.5.2+ds.1-2/debian/patches/skip-pyarrow-tests.patch	2024-06-20 19:21:07.000000000 +0000
@@ -257,3 +257,13 @@ Forwarded: no
  @gen_cluster(client=True)
  async def test_merge_unknown_to_unknown(
      c,
+--- dask.distributed.orig/distributed/shuffle/tests/test_metrics.py
++++ dask.distributed/distributed/shuffle/tests/test_metrics.py
+@@ -68,6 +68,7 @@
+ 
+ 
+ @gen_cluster(client=True)
++@pytest.importorskip("pyarrow")
+ async def test_dataframe(c, s, a, b):
+     """Metrics are *almost* agnostic in dataframe shuffle vs. array rechunk.
+     The only exception is the 'p2p-shards' metric, which is implemented separately.
diff -pruN 2024.5.2+ds.1-1/debian/rules 2024.5.2+ds.1-2/debian/rules
--- 2024.5.2+ds.1-1/debian/rules	2024-06-16 16:45:33.000000000 +0000
+++ 2024.5.2+ds.1-2/debian/rules	2024-06-20 19:21:07.000000000 +0000
@@ -1,6 +1,105 @@
 #!/usr/bin/make -f
 
-SKIP=test_git_revision or test_jupyter_idle_timeout_returned or test_process_executor_kills_process or test_steal_twice or test_client_worker
+SKIP=test_git_revision \
+  or test_jupyter_idle_timeout_returned \
+  or test_process_executor_kills_process \
+  or test_steal_twice or test_client_worker
+
+# These tests need an Internet access to pass properly.  Please use
+# build environment that properly hides the host's network card to
+# capture newer such tests (e.g. chroot mode "unshare" or lxc).
+NET_SKIP=test_BatchedSend \
+  or test_send_before_start \
+  or test_send_after_stream_start \
+  or test_send_before_close \
+  or test_close_closed \
+  or test_close_twice \
+  or test_sending_traffic_jam \
+  or test_serializers \
+  or test_repr_localcluster \
+  or test_rebalance_sync \
+  or test_quiet_client_close \
+  or test_dashboard_link_inproc \
+  or test_mixing_clients_different_scheduler \
+  or test_file_descriptors_dont_leak \
+  or test_dashboard_link_cluster \
+  or test_shutdown \
+  or test_shutdown_localcluster \
+  or test_shutdown_stops_callbacks \
+  or test_shutdown_is_quiet_with_cluster \
+  or test_client_is_quiet_cluster_close \
+  or test_async_with \
+  or test_security_loader \
+  or test_security_loader_ignored_if_explicit_security_provided \
+  or test_security_loader_ignored_if_returns_none \
+  or test_close_loop_sync_start_new_loop \
+  or test_close_loop_sync_use_running_loop \
+  or test_server \
+  or test_server_raises_on_blocked_handlers \
+  or test_rpc_default \
+  or test_rpc_tcp \
+  or test_rpc_tls \
+  or test_rpc_inproc \
+  or test_rpc_message_lifetime_default \
+  or test_rpc_message_lifetime_tcp \
+  or test_rpc_message_lifetime_inproc \
+  or test_rpc_with_many_connections_tcp \
+  or test_rpc_with_many_connections_inproc \
+  or test_large_packets_inproc \
+  or test_identity_tcp \
+  or test_identity_inproc \
+  or test_ports \
+  or test_errors \
+  or test_send_recv_args \
+  or test_send_recv_cancelled \
+  or test_connection_pool \
+  or test_connection_pool_close_while_connecting \
+  or test_connection_pool_outside_cancellation \
+  or test_connection_pool_respects_limit \
+  or test_connection_pool_tls \
+  or test_connection_pool_remove \
+  or test_counters \
+  or test_compression \
+  or test_rpc_serialization \
+  or test_deserialize_error \
+  or test_connection_pool_detects_remote_close \
+  or test_close_properly \
+  or test_server_comms_mark_active_handlers \
+  or test_close_fast_without_active_handlers \
+  or test_close_grace_period_for_handlers \
+  or test_messages_are_ordered_bsend \
+  or test_messages_are_ordered_raw \
+  or test_jupyter_server \
+  or test_jupyter_idle_timeout \
+  or test_worker_uses_same_host_as_nanny \
+  or test_scheduler_file \
+  or test_worker_preload_text \
+  or test_preload_manager_sequence \
+  or test_preload_import_time \
+  or test_failure_doesnt_crash_scheduler \
+  or test_scheduler_file \
+  or test_dashboard_host \
+  or test_async_context_manager \
+  or test_allowed_failures_config \
+  or test_finished \
+  or test_no_dangling_asyncio_tasks \
+  or test_multiple_listeners \
+  or test_tls_listen_connect \
+  or test_require_encryption \
+  or test_tls_temporary_credentials_functional \
+  or test_threadpoolworkers_pick_correct_ioloop \
+  or test_security_dict_input_no_security \
+  or test_locked_comm_drop_in_replacement \
+  or test_locked_comm_intercept_read \
+  or test_locked_comm_intercept_write \
+  or test_freeze_batched_send \
+  or test_ensure_no_new_clients \
+  or test_plugin_exception \
+  or test_plugin_multiple_exceptions \
+  or test_plugin_internal_exception \
+  or test_scheduler_file \
+  or test_host_uses_scheduler_protocol \
+  or test_dont_override_default_get
 
 export PYBUILD_NAME=distributed
 export PYBUILD_TEST_ARGS=$(CURDIR)/distributed/tests -v \
@@ -11,7 +110,9 @@ export PYBUILD_TEST_ARGS=$(CURDIR)/distr
   --ignore=.github \
   --timeout-method=signal \
   --timeout=300 \
-  -m "not (avoid_ci or isinstalled or slow)" -k "not ( $(SKIP) )"
+  -m "not (avoid_ci or isinstalled or slow)" \
+  -k "not ( $(SKIP) or $(NET_SKIP) )"
+
 # FIXME: several tests are tripping on the missing dask_expr raising
 # FutureWarnings on dask.dataframe module import.  Setting configuration
 # option "dataframe.query-planning" to False will not raise such
@@ -19,7 +120,7 @@ export PYBUILD_TEST_ARGS=$(CURDIR)/distr
 export PYBUILD_BEFORE_TEST=\
   mkdir -pv {home_dir}/.config/ \
   && printf '\173 "dataframe": \173 "query-planning": False \175 \175\n' \
-  > {home_dir}/.config/dask
+     > {home_dir}/.config/dask
 
 export NEEDED_JS=distributed/http/static/js/anime.min.js \
                  distributed/http/static/js/reconnecting-websocket.min.js
@@ -74,3 +175,10 @@ override_dh_auto_clean:
 	dh_auto_clean
 	-rm $(NEEDED_JS)
 	-chmod 755 distributed/tests/test_utils_test.py
+
+before-pybuild-autopkgtest:
+	# Copy some test resources missing in autopkgtest-pkg-pybuild context.
+	mkdir -pv ../../autopkgtest_tmp/build/
+	cp -rv distributed/tests/testegg-*-py*.egg \
+		distributed/tests/mytest.pyz \
+		../../autopkgtest_tmp/build/
diff -pruN 2024.5.2+ds.1-1/debian/source/lintian-overrides 2024.5.2+ds.1-2/debian/source/lintian-overrides
--- 2024.5.2+ds.1-1/debian/source/lintian-overrides	2024-06-16 16:45:33.000000000 +0000
+++ 2024.5.2+ds.1-2/debian/source/lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-# There is tight version coupling expected by upstream of both dask and
-# dask.distributed, making this construction actually valid in that very
-# specific scenario.
-dask.distributed source: version-substvar-for-external-package Depends ${source:Version} python3-distributed -> python3-dask [debian/control:56]
diff -pruN 2024.5.2+ds.1-1/debian/tests/run-tests 2024.5.2+ds.1-2/debian/tests/run-tests
--- 2024.5.2+ds.1-1/debian/tests/run-tests	2024-06-16 16:45:33.000000000 +0000
+++ 2024.5.2+ds.1-2/debian/tests/run-tests	2024-06-20 19:21:07.000000000 +0000
@@ -44,6 +44,14 @@ SKIP_TESTS="test_localcluster_get_client
   or test_client_worker \
   or test_steal_twice \
 "
+# FIXME: the following test item is pending resolution of [1].  Deeply
+# nested structures may be generated with dask.distributed profiling
+# code, and since python3.12, somehow the TypeError is not raised
+# anymore.  Probable outcome will be a RecursionError, which may
+# mismatch some expectations downstream.
+#
+# [1]: https://github.com/dask/distributed/issues/8700
+SKIP_TESTS="$SKIP_TESTS or test_deeply_nested_structures"
 
 # FIXME: several tests are tripping on the missing dask_expr raising
 # FutureWarnings on dask.dataframe module import.  Setting configuration
